//
//  KeyBoardView.m
//  KeyboadCustom
//
//  Created by shenhuait on 2017/8/10.
//  Copyright © 2017年 shenhuait. All rights reserved.
//

#import "KeyBoardView.h"

@interface KeyBoardView()
@property (nonatomic,assign)CGFloat keyHeight;
@property (nonatomic,strong)UIButton *button;
@end
@implementation KeyBoardView

- (id)initWithFrame:(CGRect)frame{
    if (self = [super initWithFrame:frame]) {
//           [self show];
//        self.frame = CGRectMake(0, 0, kScrenWidth, kScrenHeight);
//        self.backgroundColor = [UIColor whiteColor];
        [self customView];
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(kWillShow:) name:UIKeyboardWillShowNotification object:nil];
    }
    return self;
}

- (void)customView{
    _textBgView = [[UIView alloc]initWithFrame:CGRectMake(0,0, self.frame.size.width, 40)];
    _textBgView.backgroundColor = [UIColor whiteColor];
    [self addSubview:_textBgView];
    
    _textField = [[UITextField alloc]initWithFrame:CGRectMake(10, 5, _textBgView.frame.size.width-80, 30)];
    _textField.placeholder =@"请输入2-100个字";
    _textField.textColor = [UIColor blackColor];
    _textField.font = [UIFont systemFontOfSize:14];
//    _textField.backgroundColor = [UIColor purpleColor];
    _textField.borderStyle = UITextBorderStyleLine;
    [_textBgView addSubview:_textField];
    
    _sendButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _sendButton.frame = CGRectMake( _textField.frame.origin.y+_textField.frame.size.width+10,5, _textBgView.frame.size.width-_textField.frame.size.width-10, 30);
    [_sendButton setTitle:@"发送" forState:UIControlStateNormal];
    [_sendButton setTitleColor:[UIColor blueColor] forState:UIControlStateNormal];
    _sendButton.titleLabel.font = [UIFont systemFontOfSize:14];
    [_sendButton addTarget:self action:@selector(sendMsgAction:) forControlEvents:UIControlEventTouchUpInside];
    [_sendButton setBackgroundColor:[UIColor brownColor]];
    [_textBgView addSubview:_sendButton];
    
//    _textBgView.hidden = NO;
}
- (void)sendMsgAction:(UIButton *)sender{
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(kWillHide:) name:UIKeyboardWillHideNotification object:nil];
    [_textBgView endEditing:YES];
    
    if ([_delegate respondsToSelector:@selector(sendText:)]) {
        [_delegate sendText:_textField.text];
    }

}
#pragma mark - 显示 隐藏
- (void)kWillHide:(NSNotification *)noti{
    [UIView animateWithDuration:.3 animations:^{
         _textBgView.frame = CGRectMake(0, self.frame.size.height+40, self.frame.size.width, 40);
        [self hide];
    }];
}
- (void)kWillShow:(NSNotification *)noti{

     _textBgView.hidden = NO;
    [_textField becomeFirstResponder];
    CGRect keyFrame = [[noti.userInfo objectForKey:UIKeyboardFrameEndUserInfoKey]CGRectValue];
    CGFloat keyHeight = keyFrame.size.height;
    _keyHeight = keyHeight;
    self.backgroundColor=[UIColor colorWithWhite:0.4 alpha:0.0];
    _textBgView.frame = CGRectMake(0,self.frame.size.height-keyHeight-40, self.frame.size.width, 40);
    
    [UIView animateWithDuration:.3 animations:^{
        [self layoutIfNeeded];
    }];
}

- (void)show:(UIViewController *)vc{
    if (vc == nil) {
        [[UIApplication sharedApplication].delegate.window.rootViewController.view addSubview:vc.view];
    }else{
        [self addSubview:vc.view];
    }
}
- (void)show{
    
    UIWindow *window = [[UIApplication sharedApplication]keyWindow];
    
    UIButton *button = [[UIButton alloc]init];
    [button setBackgroundColor:[UIColor blackColor]];
    button.alpha = 0.4;
    button.frame = [[UIScreen mainScreen]bounds];
    [window addSubview:button];
    [window addSubview:self];
   
    [button addTarget:self action:@selector(hide) forControlEvents:UIControlEventTouchUpInside];

    _button = button;
}


- (void)hide{
    [UIView animateWithDuration:.2 animations:^{
     
        [self removeFromSuperview];
        [_button removeFromSuperview];
        _button = nil;
       
    } completion:^(BOOL finished) {

    }];
}
@end
